> For a complete page index, fetch https://docs.transak.com/llms.txt

# Transaction Session API

POST https://api-gateway-stg.transak.com/api/v2/transaction-session
Content-Type: application/json

Creates a Headless Google Pay transaction session. Returns a `sessionId` for your integration. Requires a valid partner access token and approved KYC where applicable.

**Note:** Ensure the `quoteId` was generated with `paymentMethod` set to `google_pay`.

Reference: https://docs.transak.com/api/whitelabel/payments/headless-google-pay/transaction-session-api

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: whitelabel-api
  version: 1.0.0
paths:
  /api/v2/transaction-session:
    post:
      operationId: transaction-session-api
      summary: Transaction Session API
      description: >-
        Creates a Headless Google Pay transaction session. Returns a `sessionId`
        for your integration. Requires a valid partner access token and approved
        KYC where applicable.


        **Note:** Ensure the `quoteId` was generated with `paymentMethod` set to
        `google_pay`.
      tags:
        - subpackage_headlessGooglePay
      parameters:
        - name: x-user-ip
          in: header
          description: >-
            End user's originating IP. More details
            [here](/guides/mandatory-security-changes#user-ip-header-in-apis)
          required: true
          schema:
            type: string
        - name: x-api-key
          in: header
          description: >-
            Your Partner API key. You can find this in the [Partner
            Dashboard](https://docs.transak.com/guides/how-to-create-partner-dashboard-account#open-the-developers-section).
          required: true
          schema:
            type: string
        - name: x-access-token
          in: header
          description: >-
            Your Partner Access Token. Please refer
            [here](/guides/how-to-create-partner-access-token) for a tutorial on
            generating your access token.


            Note: This is applicable only for [Auth Reliance
            Flows](/features/auth-reliance)
          required: false
          schema:
            type: string
        - name: x-user-identifier
          in: header
          description: >-
            The authenticated user's email address.

            Note: This is applicable only for [Auth Reliance
            Flows](/features/auth-reliance).
          required: false
          schema:
            type: string
        - name: authorization
          in: header
          description: >-
            Authorization token is the accessToken received from the API -`
            api/v2/auth/verify`


            Note: This is not applicable for [Auth Reliance
            Flows](/features/auth-reliance)
          required: false
          schema:
            type: string
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/headlessGooglePay:TransactionSessionSuccessResponse
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/headlessCards:ApiErrorBody'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/headlessCards:ApiErrorBody'
        '422':
          description: Unprocessable Entity
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/headlessCards:ApiErrorBody'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/headlessCards:ApiErrorBody'
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/headlessGooglePay:CreateTransactionSessionRequest
servers:
  - url: https://api-gateway-stg.transak.com
    description: Staging
components:
  schemas:
    headlessGooglePay:CreateTransactionSessionRequestConfigColorMode:
      type: string
      enum:
        - DARK
        - LIGHT
      description: UI color mode for the Google Pay flow.
      title: CreateTransactionSessionRequestConfigColorMode
    headlessGooglePay:CreateTransactionSessionRequestConfig:
      type: object
      properties:
        colorMode:
          $ref: >-
            #/components/schemas/headlessGooglePay:CreateTransactionSessionRequestConfigColorMode
          description: UI color mode for the Google Pay flow.
      description: Additional optional UI configuration passed through to the session.
      title: CreateTransactionSessionRequestConfig
    headlessGooglePay:CreateTransactionSessionRequestBillingAddress:
      type: object
      properties:
        addressLine1:
          type: string
        addressLine2:
          type: string
        city:
          type: string
        state:
          type: string
        postCode:
          type: string
        country:
          type: string
        countryCode:
          type: string
      description: Auto-fetched from user profile if omitted (Google Pay only).
      title: CreateTransactionSessionRequestBillingAddress
    headlessGooglePay:CreateTransactionSessionRequest:
      type: object
      properties:
        quoteId:
          type: string
          description: Quote ID from the [Quotes API](/api/whitelabel/lookup/get-quote).
        walletAddress:
          type: string
          description: Destination crypto wallet address.
        config:
          $ref: >-
            #/components/schemas/headlessGooglePay:CreateTransactionSessionRequestConfig
          description: Additional optional UI configuration passed through to the session.
        successUrl:
          type: string
          description: Redirect URL on payment success.
        failureUrl:
          type: string
          description: Redirect URL on payment failure.
        billingAddress:
          $ref: >-
            #/components/schemas/headlessGooglePay:CreateTransactionSessionRequestBillingAddress
          description: Auto-fetched from user profile if omitted (Google Pay only).
      required:
        - quoteId
        - walletAddress
        - successUrl
        - failureUrl
      title: CreateTransactionSessionRequest
    headlessGooglePay:TransactionSessionData:
      type: object
      properties:
        sessionId:
          type: string
          description: Session token for the Headless Google Pay flow.
        expiresAt:
          type: string
          format: date-time
          description: Session expiration timestamp.
      required:
        - sessionId
        - expiresAt
      title: TransactionSessionData
    headlessGooglePay:TransactionSessionSuccessResponse:
      type: object
      properties:
        data:
          $ref: '#/components/schemas/headlessGooglePay:TransactionSessionData'
      required:
        - data
      title: TransactionSessionSuccessResponse
    headlessCards:ApiErrorBodyError:
      type: object
      properties:
        statusCode:
          type: integer
        message:
          type: string
        errorCode:
          type: integer
          description: Machine-readable error code for client handling.
      required:
        - statusCode
        - message
      title: ApiErrorBodyError
    headlessCards:ApiErrorBody:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/headlessCards:ApiErrorBodyError'
      required:
        - error
      title: ApiErrorBody

```

## Examples



**Request**

```json
{
  "quoteId": "",
  "walletAddress": "",
  "successUrl": "",
  "failureUrl": "",
  "config": {
    "colorMode": "DARK"
  }
}
```

**Response**

```json
{
  "data": {
    "sessionId": "eyJhbGciOiJFZERTQSIsInR5cCI6IkpXVCJ9.eyJvdHQiOiJjOTU4NTQ0MzQzZjI4YjM4NGQ5OGExM2JjZmU3OTk2YSIsImlhdCI6MTc4MDM2ODM3MywiZXhwIjoxNzgwMzY4OTczfQ.BLlwJbGrH-jRBwAWhJgPIDmcDFYvpIOZCMEVaZhhB4RC3LovyeFj8qeT5GYzR5aA6oO6JMOQM419mWYZS53yDg",
    "expiresAt": "2026-06-02T02:56:13.000Z"
  }
}
```

**SDK Code**

```python Success
import requests

url = "https://api-gateway-stg.transak.com/api/v2/transaction-session"

payload = {
    "quoteId": "",
    "walletAddress": "",
    "successUrl": "",
    "failureUrl": "",
    "config": { "colorMode": "DARK" }
}
headers = {
    "x-user-ip": "",
    "x-api-key": "",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Success
const url = 'https://api-gateway-stg.transak.com/api/v2/transaction-session';
const options = {
  method: 'POST',
  headers: {'x-user-ip': '', 'x-api-key': '', 'Content-Type': 'application/json'},
  body: '{"quoteId":"","walletAddress":"","successUrl":"","failureUrl":"","config":{"colorMode":"DARK"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Success
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api-gateway-stg.transak.com/api/v2/transaction-session"

	payload := strings.NewReader("{\n  \"quoteId\": \"\",\n  \"walletAddress\": \"\",\n  \"successUrl\": \"\",\n  \"failureUrl\": \"\",\n  \"config\": {\n    \"colorMode\": \"DARK\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-user-ip", "")
	req.Header.Add("x-api-key", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Success
require 'uri'
require 'net/http'

url = URI("https://api-gateway-stg.transak.com/api/v2/transaction-session")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-user-ip"] = ''
request["x-api-key"] = ''
request["Content-Type"] = 'application/json'
request.body = "{\n  \"quoteId\": \"\",\n  \"walletAddress\": \"\",\n  \"successUrl\": \"\",\n  \"failureUrl\": \"\",\n  \"config\": {\n    \"colorMode\": \"DARK\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java Success
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api-gateway-stg.transak.com/api/v2/transaction-session")
  .header("x-user-ip", "")
  .header("x-api-key", "")
  .header("Content-Type", "application/json")
  .body("{\n  \"quoteId\": \"\",\n  \"walletAddress\": \"\",\n  \"successUrl\": \"\",\n  \"failureUrl\": \"\",\n  \"config\": {\n    \"colorMode\": \"DARK\"\n  }\n}")
  .asString();
```

```php Success
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api-gateway-stg.transak.com/api/v2/transaction-session', [
  'body' => '{
  "quoteId": "",
  "walletAddress": "",
  "successUrl": "",
  "failureUrl": "",
  "config": {
    "colorMode": "DARK"
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '',
    'x-user-ip' => '',
  ],
]);

echo $response->getBody();
```

```csharp Success
using RestSharp;

var client = new RestClient("https://api-gateway-stg.transak.com/api/v2/transaction-session");
var request = new RestRequest(Method.POST);
request.AddHeader("x-user-ip", "");
request.AddHeader("x-api-key", "");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"quoteId\": \"\",\n  \"walletAddress\": \"\",\n  \"successUrl\": \"\",\n  \"failureUrl\": \"\",\n  \"config\": {\n    \"colorMode\": \"DARK\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Success
import Foundation

let headers = [
  "x-user-ip": "",
  "x-api-key": "",
  "Content-Type": "application/json"
]
let parameters = [
  "quoteId": "",
  "walletAddress": "",
  "successUrl": "",
  "failureUrl": "",
  "config": ["colorMode": "DARK"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api-gateway-stg.transak.com/api/v2/transaction-session")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```